// "The Toon Lab" full source code by Eric David
// for the 09/2000 and 10/2000 IRTC

#include "colors.inc"
#include "textures.inc"
#include "metals.inc"

#declare R1 = seed(0);
#declare R2 = seed(10);

#declare eps = 0.2;

#declare Verre = texture { pigment { color rgbf <1,1,1,0.95> } 
                           finish { ambient 1 diffuse 0 specular 0.2 roughness 0.05 }
                           }
#declare Flash = texture { pigment { color rgb <1,0,0> } 
                           finish { ambient 0.4 diffuse 0.6 specular 0.4 roughness 0.2}
                           }
#declare Plastic = texture { pigment { color rgb <1,1,1> } 
                           finish { ambient 0.4 diffuse 0.6 specular 0.2 roughness 0.2}
                           }

#declare Graduation = texture { pigment { gradient y color_map {[0 Black][0.1 rgbf <1,1,1,0.9>]} scale 1 } 
                           finish { ambient 1 }
                           }

#declare Verre_Cyan_Clean = texture { pigment { color rgb <0.9,1,1> } 
                    finish { ambient 0.3 diffuse 0.5 specular 0.1 reflection 0.1 }}

/*#declare Verre_Cyan_Taches = texture { pigment { color rgb <0.9,1,1> } 
                    finish { ambient 0.3 diffuse 0.5 specular 0.1 reflection 0.1 }}
                    texture { pigment {marble  color_map{[0 Clear][1 Green]} turbulence 1}
                      finish { ambient 0.8 diffuse 0 specular 0 }
                      scale 1/10 }*/
/*#declare Verre_Cyan = texture { leopard texture_map {[0.2 Verre_Cyan_Clean][0.3 Verre_Cyan_Taches]}
                        scale 10 }*/
#declare Verre_Cyan = texture { Verre_Cyan_Clean }
//#declare Bois = texture { T_Wood3 finish { ambient 0.5 } scale 0.2 }

#declare Bursol = texture {pigment { bozo color_map {[0 Yellow][1 Yellow*0.6]} turbulence 1 scale 1 }
                        finish { ambient 0.5 diffuse 0.5 specular 0.2 } 
                        normal { bozo 2 } } // couleur cheveux
#declare Smurf = texture { 
  pigment { color rgb <1,0.7,0.55> } 
  finish { ambient 0.5 diffuse 0.5 specular 0.1 }
  normal { bozo 2 }}


#declare Tube_a_essai = 
union { 
        difference { 
                sphere { <0,0,0>,1 } 
                sphere { <0,0,0>,1-eps }
                box { <-2,0,-2>,<2,2,2> }
                }
        difference {
                cylinder { <0,0,0>,<0,10,0>,1 }
                cylinder { <0,-1,0>,<0,11,0>,1-eps }
                } 
        difference {
                torus { 1-eps/2,eps/2 translate <0,10,0> }
                box { <-2,9,-2>,<2,10,2> }
                }
        texture { Verre }       
       }

#declare R = 3; // rayon du Becher
#declare K = 0.5;
#declare H = 7; 

#declare Coupelle =
union {
        difference { 
                torus { R-K,K } 
                torus { R-K,K-eps } 
                cylinder { <0,-5,0>,<0,5,0>,R-K }
                cylinder { <0,0,0>,<0,5,0>,R+eps }
                }
        cylinder { <0,-K,0>,<0,-K+eps,0>,R-K } 
}
       
#declare Becher = 
union {
        object { Coupelle }
        difference {
                cylinder { <0,0,0>,<0,H,0>,R }
                cylinder { <0,-1,0>,<0,H+1,0>,R-eps }
                } 
        difference {
                torus { R-eps/2,eps/2 translate <0,H,0> }
                box { <-2,9,-2>,<2,H,2> }
                }
texture { Verre }
}       

#declare Becher_Solution = 
union {
        cylinder { <0,-K+eps,0>,<0,0,0>,R-K-0.01 }
        torus { R-K,K-eps } 
        cylinder { <0,0,0>,<0,H/2,0>,R-eps-0.01 }
}       

#declare Solution = 
union { 
       sphere { <0,0,0>,0.99-eps }
       cylinder { <0,0,0>,<0,10,0>,0.99-eps }
       }

/// ************* PETIT OUTILS TSL2RGB *************

// Algorithmes d'aprs "Introduction  l'infographie"
// chez Addison-Wesley
// Les parametres sl sont compris entre 0 et 1
// t est en degre (dans [0, 360])

#macro TSL2RGB(T0,S0,L0) // la couleur renvoyee est "C"

#local T = T0;
#local S = S0;
#local L = L0;

#if (S <= 0.)
#declare C = <L,L,L>;
#else

#while (T >= 360) 
#local T = T-360;
#end

#while (T < 0) 
#local T = T+360;
#end

#if (S > 1) 
#local S = 1;
#end

#local T = T/60.0;
#local I = floor(T);
#local F = T-I;
#local P = L*(1-S);
#local Q = L*(1-S*F);
#local X = L*(1-S*(1-F));

#switch(I) 
#case (0) #declare C = <L,X,P>; #break
#case (1) #declare C = <Q,L,P>; #break
#case (2) #declare C = <P,L,X>; #break;
#case (3) #declare C = <P,Q,L>; #break;
#case (4) #declare C = <X,P,L>; #break;
#case (5) #declare C = <L,P,Q>; #break;
#else #declare C = <0,0,0>; #break;
#end // switch
#end // else
#end // macro

/// ************* ADMIN ************* 
         
//#declare CAM = <5,10,5>;
#declare CAM = <30,20,20>;
camera { location CAM look_at <0,0,5> }
//camera { location CAM look_at <-30,0,-20> }
union {
//light_source { <30,20,20> color White*2 fade_distance 50 fade_power 3 }
//light_source { CAM color White fade_distance 50 fade_power 3 }
//light_source { CAM+<-5,5,5> color White }
light_source { CAM+<50,50,50> color White spotlight point_at <0,0,0> radius 100 falloff 5 tightness 30 }
         
/// ************* TABLE ET PIECE *************

// Convert jpg to gif
#declare Carreaux = texture { pigment { image_map { gif "CBrick.gif" } scale 10 }
        finish { ambient 0.5 diffuse 0.5 }} 
                           
box { <-30,-1.5,-30>,<30,-2,30> texture { Verre_Cyan }}
//box { <-30,-15,-30>,<-30,-100,30> texture { Carreaux rotate x*90}} // sol
box { <-30,-100,-30>,<-30,100,80> texture { Carreaux rotate y*90}} // mur droite
box { <-30,-100,-30>,<80,100,-30> texture { Carreaux }} // mur gauche

/// ************* CADRE DE TOONSEA *************

/* // facultatif
union {
#declare R0 = 0.2;

union {
cylinder { <0,-R0,-R0>,<0,6+R0,-R0>,R0 }
cylinder { <0,-R0,8+R0>,<0,6+R0,8+R0>,R0 }
cylinder { <0,6+R0,8+R0>,<0,6+R0,-R0>,R0 }
cylinder { <0,-R0,-R0>,<0,-R0,8+R0>,R0 }
sphere { <0,8,4>,R0 }
texture { Flash pigment { rgb <0.7,0.7,0.7> } finish { specular 0.4 }}
}
union {
cylinder { <0,6+R0,2>,<0,8,4>,R0/3 }
cylinder { <0,6+R0,6>,<0,8,4>,R0/3 }
texture { Flash pigment { White*0.8 } finish { specular 0.4 }}
}
// "The Toon Sea" image is available at the 07/2000 and 08/2000 IRTC
// Greyscale it, gamma * 2, and it's okay
box { <0,0,0>,<0.1,1,1> texture { pigment { image_map { gif "toonsea.gif" } rotate y*-90 }}
        finish { ambient .8 diffuse 0 } scale <1,6,8> }
scale 1.5
translate <-30,2,16>
}
*/

union {
/// ************* PORTE TUBE A ESSAIS *************
   
difference {         
box { <-18,-1.5,-3>,<18,7.5,3> }
box { <-17,-1,-4>,<17,7,4> }
#declare i = -5;
#declare M = 5;
#while (i<=M)
cylinder { <0,0,0>,<0,10,0>,1 translate <i*3,0,1.5> }
#declare i = i+1;
#end
texture { Verre_Cyan_Clean pigment { White } }
} 

/// ************* TUBE A ESSAIS *************

#declare i = -5;
#declare M = 5;
#while (i<=M)
object { Tube_a_essai translate <i*3,0, 1.5> }
//object { Tube_a_essai translate <i*3,0,-1.5> }
#declare i = i+1;
#end

/// ************* SOLUTIONS *************

#declare i = -5;
#declare M = 5;
#while (i<=M)

#declare tz = sin(cos(i*(i+5))*55)*4+5;

#declare C0 = <1,1,1>; // au fond
TSL2RGB(i*360/(2*M),1,1)

#declare tex = texture { 
  pigment { gradient y color_map {[0 rgb C0][1 rgb C]} scale (tz+1)*1.01 translate -y } 
  finish { ambient 0.5 diffuse 0.5 specular 0.2 }
  normal { bozo 2 }}

difference {
  object { Solution texture { tex }}
  box { <-2,tz,-2>,<2,11,2> texture {tex normal { ripples 1 scale 0.05 }}}
  
  translate <i*3,0,1.5> 
  } // diff
#declare i = i+1;
#end

translate <0,0,-27>
}


/// ************* COUPELLE *************

#declare Powder = <1,0.1,0.1>; // <0.44,0.86,0.58>;

object { Coupelle texture { T_Chrome_5C } scale <2,1,2> translate <-15,K-1.5,-10> }
cone { <0,K-1.5,0>,3,<0,K+.5,0>,0.4 texture { pigment { color Powder } finish { ambient 0.5 diffuse 0.5 }
                normal { bozo 0.5 scale 0.1 }} translate <-15,-1,-10> }


/// ************* TORTILLON *************


#macro tortillon(r,maxim) blob {
threshold 0.3
#declare i = 0;
#declare M = 200;
#while (i <= M*maxim)    
#declare p = i/M; // parametre
#declare beta = p*14*pi;
#declare rot = -z*(p)*90;
#declare ray = (p > 0.2 ? 1 : p/0.2);
#declare pos = <cos(beta),0,sin(beta)>*3*ray+x*-10;
sphere { pos,r,0.4 rotate rot translate <10,7,0> }
#declare i = i + 1;
#end
}
#end

#declare Puff = texture { 
  pigment { color rgbf (<1,0.7,0.55,0.8>*1.5-0.5*<1,1,1,1>) } 
  finish { ambient 1 specular 0 }
  }

#declare Liquide = texture { 
//  pigment { bozo color_map{[0.3 rgb <1,0.7,.55>][.5 rgb <1,1,1>][.7 rgb <1,0.7,0.55>]} scale 0.5} 
  pigment { color (Powder*0.4+<1,1,1,1>*0.4) } 
  finish { ambient 0.7 diffuse 0.4 specular 0.3 }
  }
  
#declare Liquide_Surf = texture { Liquide 
  normal { bozo 20 scale 0.5 }
}

union { // alambic

union { tortillon(1,1)
        cylinder { <0,K,0>,<0,7,0>,0.5 }
        cone { <10,14,0>,0.5,<10,10,0>,1 }
        cone { <10,4+3*0.5,0>,3,<10,10,0>,1 }              
difference {
        sphere { <10,3,0>,3 scale <1,0.5,1> translate y*4 } 
        box { <0,10,-10>,<20,4+1.5,10> }
        }
        texture { Verre pigment { color rgbf <1,1,1,0.8> } }}
union { tortillon(1-eps,6.5/7) // vapeur 
        cylinder { <0,K,0>,<0,7,0>,0.5-eps }
        texture { gradient y texture_map {[0 Puff][1 pigment { Clear }]} scale <1,20,1> } }

// amont
union { // bec benzene
cylinder { <10,0,0>,<10,3,0>,3 }
sphere { <10,0,0>,3 scale <1,1/3,1> translate y*3 } 
texture { pigment { Blue } finish { ambient 0.3 specular 0.2 }}
}
union { // metallique
torus { 3,.2 translate <10,4,0> }
#declare M = 15;
#declare i = 0;
#while (i < M)    
#declare p = i/M; // parametre
#declare rot = p*360*y;
cylinder { <0,4,2.9>,<0,4.5,2.9>,0.3 rotate rot translate <10,0,0> }
#declare i = i + 1;
#end
texture { T_Chrome_5E }
}

difference { // liquide
        union {
        cone { <10,4+(3-eps)*0.5,0>,3-eps,<10,10,0>,1-eps }              
        sphere { <10,3,0>,3-eps scale <1,0.5,1> translate y*4 } 
        texture { Liquide }
        }
        box { <0,6.5,-10>,<20,12,10>         texture { Liquide_Surf }
}
}

blob { threshold 0.3
#declare i = 0;
#while (i < M)    
#declare p = i/M; // parametre
#declare rot = p*360*y;
#declare R0 = 1;
sphere { <0,R0*0.7,2.9>,R0,0.4 scale <1,2+rand(R1)*0,1> rotate rot translate <10,0,0> 
texture { pigment { gradient y color_map {
[0 rgbf <1,1,1,0.5>]
[0.3 rgbf <1,1,0,0.6>]
[0.5 rgbf <1,.5,0,0.6>]
[0.7 rgbf <1,0,0,0.7>]
[1 Clear]
} scale 4 } finish { ambient 1 }}}
#declare i = i + 1;
#end
translate y*4
} // flammes        


/*union {
#declare i = 0;
#while (i < M)    
#declare p = i/M; // parametre
#declare rot = p*360*y;
sphere { <0,0,0>,1 
texture { pigment { cylindrical color_map {
[0 Clear]
[0.3 rgbf <0,0,1,0.7>]
[0.5 rgbf <0,.5,1,0.6>]
[0.7 rgbf <0,1,1,0.6>]
[1 rgbf <1,1,0,0.5>]
} rotate x*90 turbulence 0.3 rotate y*50} finish { ambient 1 }}
scale <.5,1,.2>
translate <0,0.7,2.9>
rotate rot
translate <10,4,0> 
}
#declare i = i + 1;
#end
}*/ // flammes        
        
// aval
object { Becher          translate <0,K,0> texture { Verre } }
difference {
object { Becher_Solution translate <0,K,0> }
box { <-10,2,-10>,<10,15,10> }
texture { Smurf } 
}


translate <0,-1.5,-10>
} // union alambic


/// ************* 3 BECHERS *************

// yeux

#declare Machoire = texture {
          pigment { image_map { gif "jaw.gif" map_type 2} rotate y*90 translate <0,5+K+.5,0> }
          finish { ambient 0.5 diffuse 0.5 }}


#declare Yeux1 = union {
cone { <0,5+K+2.5,0>,0,<R+.1,5+K+2.5,-.5>,.5 }
cone { <0,5+K+2.5,0>,0,<R+.1,5+K+2.5, .5>,.5 }
}        
#macro Yeux2(x1,y1,x2,y2) 
union {
cone { <0,5+K+2.5,0>,0,<R+.2,5+K+2.5+y1,(x1=0?-.4:-.5+x1)>,.2 }
cone { <0,5+K+2.5,0>,0,<R+.2,5+K+2.5+y2,(x2=0?.4:.5+x2)>,.2 }
}
#end
#declare Contour1 = difference { cylinder { <0,0,0>,<0,H+K+10,0>,R+10  }
cylinder { <0,-1,0>,<0,H+K+11,0>,R-eps-0.005  } }
#declare Contour2 = difference { cylinder { <0,0,0>,<0,H+K+10,0>,R+10  }
cylinder { <0,-1,0>,<0,H+K+11,0>,R-eps-0.001  } }

object { Becher          translate <-30+R,K-1.5,-30+R    > texture { Verre } }
object { Becher_Solution translate <-30+R,K-1.5,-30+R    > texture { Smurf } }
object { Becher          translate <-30+R,K-1.5,-30+R+3*R> texture { Verre } }
object { Becher_Solution translate <-30+R,K-1.5,-30+R+3*R> texture { Smurf } }
object { Becher          translate <-30+R,K-1.5,-30+R+6*R> texture { Verre } }
object { Becher_Solution translate <-30+R,K-1.5,-30+R+6*R> texture { Smurf } }
      
union { // Yeux de Becher 1      
difference { // partie blanche
object { Yeux1 } object { Contour1 }
texture { pigment { White } finish {ambient 1}} }
difference { // partie noire
Yeux2(.3,0,.3,0) object { Contour2 } texture { pigment { Black} finish {ambient 1}}  }
difference {      // machoire
sphere { <R-.4,K+1+5,0>,.5 scale <1,1,4> }
object { Contour1 } texture { Machoire } }
rotate y*-45
translate <-30+R,-1.5-5,-30+R> 
}

union { // Yeux de Becher 2      
difference { // partie blanche
object { Yeux1 } object { Contour1 }
texture { pigment { White } finish {ambient 1}} }
difference { // partie noire
Yeux2(-.3,0,-.3,0) object { Contour2 } texture { pigment { Black} finish {ambient 1}}  }
difference {      // machoire
sphere { <R-.4,K+1+5,0>,.5 scale <1,1,4> }
object { Contour1 } texture { Machoire } }
rotate y*30
translate <-30+R,-1.5-5,-30+R+3*R> 
}

union { // Yeux de Becher 3      
difference { // partie blanche
object { Yeux1 } object { Contour1 }
texture { pigment { White } finish {ambient 1}} }
difference { // partie noire
Yeux2(0,.3,0,.3) object { Contour2 } texture { pigment { Black} finish {ambient 1}}  }
difference {      // machoire
sphere { <R-.4,K+5+.5,0>,1 scale <1,1,2> }
box { <-10,-10,-10>,<10,K+5+.5,10> }
object { Contour1 } texture { Machoire } }
rotate y*-45
translate <-30+R,-1.5-5,-30+R+R*6> 
}


/// ************* BECHER SOUS LA BURETTE *************

union { // Becher utilise

object { Becher translate <0,5+K,0> texture { Verre } }
difference {
object { Becher_Solution translate <0,5+K,0> }
cone { <0,5+K+H/2+.1,0>,R-eps,<0,5+K+H*0.3,0>,0 }
texture { Smurf }
}

sphere { <0,5+K+H/2-2>,2 texture { Bursol }} // solution de la burette dans le becher
sphere { <0,5+K+H/2+2>,.3 texture { Bursol }}

difference { // taches sur le becher

blob {
threshold 0.3
#declare i = 0;
#declare M = 20;
#while (i < M)    
#declare a = rand(R1)*2*pi;
sphere { <cos(a)*(R-eps),rand(R1)*H/2+K+H/2+4,sin(a)*(R-eps)>,1,0.4 }
#declare i = i + 1;
#end
} // blob

difference {
cylinder { <0,1,0>,<0,H+K+10,0>,R+10  }
cylinder { <0,0,0>,<0,H+K+11,0>,R-eps-0.01  }
} // diff
texture { Smurf }
}


difference { // partie blanche
object { Yeux1 } object { Contour1 }
texture { pigment { White } finish {ambient 1}} }
difference { // partie noire
Yeux2(0,0,0,0) object { Contour2 } texture { pigment { Black} finish {ambient 1}} }

// machoire
difference {      
box { <1.5,5+K+.5,-R>,<R,5+K+1.5,R> }
object { Contour1 } texture { Machoire } }

// agitateur magnetique
// signature
union {
text { ttf "timrom.ttf" "AGITATEUR" .1,0 texture { pigment { White*1 }} translate y*1 }
text { ttf "timrom.ttf" "MAGNETIQUE" 0.1,0 texture { pigment { White*1 }} }
rotate y*-90
scale <1,.5,1>
translate <5.1,3.5,-4.5> }

box { <-5,0,-5>,<5,5,5> texture { Verre_Cyan_Clean pigment { Gray40 }}}
#declare U = 0.2;
box { <5.2,1.5  ,3  >,<5,3.5  ,4  > texture { Verre_Cyan_Clean pigment { Gray40 }}}
box { <5.3,1.5+U,3+U>,<5,3.5-U,4-U> texture { pigment { gradient z color_map {[0 Yellow][1 Red]} scale .5 } finish{ambient 0.7}}}


// burette
difference {
union {
cylinder { <0,15,0>,<0,30,0>,1 }
cone { <0,15,0>,1,<0,12,0>,0.2 }
}
cylinder { <0,15,0>,<0,30,0>,1-eps }
cone { <0,15,0>,1-eps,<0,12,0>,0.1 }
texture { Graduation }
texture { Verre }
}
cylinder { <0,15,0>,<0,15,3>,.25 texture { Verre }}
cylinder { <0,15,0>,<0,15,3>,.125 texture { Plastic }}
cone { <0,15,3>,.5,<0,16,3>,0 texture {Plastic }}
cone { <0,15,3>,.5,<0,14,3>,0 texture {Plastic }}

// pied burette
union {
cone { <0,0,0>,1,<4,0,0>,0 }
cone { <0,0,0>,1,<4,0,0>,0 rotate y*120 }
cone { <0,0,0>,1,<4,0,0>,0 rotate y*240 }
sphere { <0,0,0>,1 }
cylinder { <0,0,0>,<0,30,0>,0.5 }
cylinder { <0,20,0>,<0,20,-10>,0.5 }
torus { 1,0.5 translate <0,20,-10> }
texture { T_Chrome_5A }
translate <0,0,10>
}

// solution burette
union
{
cylinder { <0,15,0>,<0,30,0>,1-eps-0.01 }
cone { <0,15,0>,1-eps,<0,12,0>,0.05 }
texture { Bursol } 
}

translate <-20,-1.5,5>
}

/// ************* BECHER CHEVELU EN BECHER *************

union {
object { Becher          translate <-10,K-1.5,25    > texture { Verre } }
object { Becher_Solution translate <-10,K-1.5,25    > texture { Smurf } }

difference {
blob { threshold 0.3 // cheveux
sphere { <0,0,0>,2*R,0.6 scale <1,.3,1> }
#declare i = 0;
#declare M = 20;
#while (i < M)
sphere { <rand(R2)*2*R-R,rand(R2)*1,rand(R2)*R*2-R>,1,0.4 scale <1,1,1> }
#declare i = i+1;
#end
}
object { Contour1 translate <0,-H/2,0> }
box { <-10,-10,-10>,<10,0,10> }
translate <-10,-1.5+K+H/2,25>
texture { Bursol }
}

union { // Yeux de Becher Chevelu      
difference { // partie blanche
object { Yeux1 } object { Contour1 }
texture { pigment { White } finish {ambient 1}} }
difference { // partie noire
Yeux2(0,.2,0,.2) object { Contour2 } texture { pigment { Black} finish {ambient 1}}  }
difference {      // machoire
box { <1.5,5+K+.5,-R>,<R,5+K+1.5,R> }
sphere { <R-.4,K+1.5+5,0>,.4 scale <1,1,4> }
sphere { <R-.3,K+0.5+5,0>,.4 scale <1,1,4> }
object { Contour1 } texture { Machoire } }
rotate y*20
translate <-10,-1.5-5,25> 
}

translate <0,0,-10>
}

/// ************* BECHER RENVERSE *************

union {        
union {        
object { Becher texture { Verre } }
difference {
cylinder { <0,0,R>,<0,H,R>,.5 scale <3,1,1> }
//box { <-5.5,0,R-.5>,<5.5,H,R> }
Contour1                     
texture { Smurf }
}
rotate x*90 translate <10,-1.5+R,-10> 
}

blob {
threshold 0.3
sphere { <0,0,0>,10,0.3 scale <1,0.2,1> }
sphere { <0,0,0>,3,0.2 scale <1,0.2,1> }
#declare i = 0;
#declare M = 20;
#while (i < M)    
#declare a = rand(R2)*2*pi;
#declare b = rand(R2);
sphere { <cos(a)*b,0,sin(a)*b>*3,1,0.29 scale <1,0.2,1> }
#declare i = i + 1;
#end
translate <10,-1.5,-10+H>
texture { Smurf }
}

translate <-10,0,10>
rotate y*110
translate <-10,0,25>
}

/// TOON QUI S'EST ECHAPPE 

#declare SC = 0.8;
#declare gros_truc = blob {
threshold 0.3
sphere { <0,0,0>,15,0.4 scale <1,0.2,1> }

#declare i = 0;
#declare M = 20;
#while (i < M)    
#declare a = rand(R2)*2*pi;
#declare b = rand(R2);
sphere { <cos(a)*b,0,sin(a)*b>*3+rand(R2)*5*(.5+b/2+rand(R2)*.5)*y,3.5,0.2 }
#declare i = i + 1;
#end

#declare i = 0;
#declare M = 20;
#while (i < M)    
#declare a = rand(R2)*2*pi;
#declare b = rand(R2);
sphere { <cos(a)*b,0,sin(a)*b>*1+5*y,1,0.4 }
#declare i = i + 1;
#end

translate <10,-1.5,10>
}

union {           
#declare A = 3;           
#declare S = <4,1,3>;
difference { 
object { gros_truc }
intersection {
sphere { <0,0,0>,1 scale S translate <13,1,10> }
box { <10-10,0,10+10>,<10+10,1,10-10>   }  }
box { <10-10,3,10+10>,<10+10,10,10-10>   } 
texture { Smurf scale 1/SC } 
}
intersection {
object { gros_truc }
sphere { <0,0,0>,3 scale S translate <13,1,10> }
box { <10-10,0,10+10>,<10+10,1,10-10>   }  
texture { Machoire translate <10,-5-K-.5,10> } 
}
intersection {
object { gros_truc }
box { <10-10,3,10+10>,<10+10,10,10-10>   } 
texture { Bursol scale 1/SC }
}

#declare Eye2 = union {
sphere { < 0,0,0>,4  pigment { White*1 } finish { ambient 0.3 diffuse 1}}
sphere { < 0,0,-2>,2.2  pigment { Gray10 } finish { ambient 0.3 diffuse 1}}
}

object { Eye2 scale 0.15 rotate x*30 rotate y*-90 translate <13,2,9.5> }
object { Eye2 scale 0.15 rotate x*30 rotate y*-90 translate <13,2,10.5> }
 
translate <-10,0,-10> 
rotate y*30
//rotate y*-70 // normal
//rotate y*-30 // face
scale SC 
translate <5,0,19>
}
/// ************* PETITES TACHES et FEUILLE DE PAPIER *************

#declare Flotte = texture { pigment { color rgbf <1,1,1,1> } 
                           finish { ambient 1 diffuse 0 specular 0.2 roughness 0.5 }
                           }

blob {
threshold 0.3
sphere { <0,0,0>,3,0.1 scale <1,0.2,1> }
#declare i = 0;
#declare M = 30;
#while (i < M)    
#declare a = rand(R2)*2*pi;
#declare b = rand(R2);
sphere { <cos(a)*b,0,sin(a)*b>*6,1,0.4 scale <1,0.2,1> }
#declare i = i + 1;
#end
translate <-5,-1.5,10>
texture { Flotte }
interior { ior 1.5 }
}

// Convert jpg to gif
box { <-15,-1.495,-10>,<15,-1.49,10> 
        texture { pigment { image_map { gif "sheet.gif" filter 233,1 } rotate <90,-90,0> translate <-.5,0,-.5> scale <30,1,20> }} 
                  finish { ambient 0.5 diffuse 0.4 }
         
rotate y*-30
//translate <5,0,5>
translate <10,0,10>
}


translate -CAM
scale 1
translate CAM
} // global union